#include-once
#Tidy_Parameters=/sort_funcs /reel

#Region DPViewer.au3 - Include
#include <MsgBoxConstants.au3>
#include <FileConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <String.au3>
#include <File.au3>
#include <WinAPIFiles.au3>
#include <Color.au3>
#EndRegion QuickPDF Include

#Region DPViewer.au3 - Header
; #INDEX# =======================================================================================================================
; Title .........: UDF for "Debenu PDF Viewer SDK"
; AutoIt Version : 3.3.10.2++
; Language ......: English
; Description ...: A collection of functions for Debenu PDF Viewer SDK
; Author(s) .....: mLipok
; Modified ......:
; ===============================================================================================================================
#cs
	Title:   UDF for "Debenu PDF Viewer SDK"
	Filename:  DPViewer.au3
	Description: A collection of functions for Debenu PDF Viewer SDK
	Author:   mLipok
	Modified:
	Last Update: 2015/04/28
	Requirements:
	AutoIt 3.3.10.2 or higher

	Debenu PDF Viewer SDK
	http://www.debenu.com/products/development/debenu-pdf-viewer-sdk/

	Update History:
	===================================================
	2014/09/29
	v0.1 First oficial version

	===================================================
	2015/04/28
	v0.2

	TODO: description and Documentation

#CE
#EndRegion QuickPDF.au3 - Header

#Region DPViewer.au3 - Global #VARIABLES#
Global $g__hDll_DPVS = 0
Global $g__bEventConsoleNotification = True
#EndRegion

#Region DPViewer.au3 - INIT
Func _DPVS_LicenceKey(ByRef $oDPVS, $sLicenceKey)
	$oDPVS.LicenseKey = $sLicenceKey
EndFunc   ;==>_DPVS_LicenceKey

Func _DPVS_Shutdown()
	_DPVS_StartUp('DllClose')
EndFunc   ;==>_DPVS_Shutdown

Func _DPVS_StartUp($sParam = Default)
	Local Static $g__hDll_DPVS = Default
	If $sParam = Default Or $sParam <> 'DllClose' Then
		If $g__hDll_DPVS = Default Then
			Local $sDLLFile
			$sDLLFile = @ScriptDir & '\DebenuPDFViewerCtrl1114.ocx'

			If FileExists($sDLLFile) Then
				$g__hDll_DPVS = DllOpen($sDLLFile)
				If $g__hDll_DPVS = -1 Then
					MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "DllOpen Error", "Can not open: " & @CRLF & $sDLLFile)
					Return -1
				Else
					Return $g__hDll_DPVS
				EndIf
			Else
				MsgBox($MB_SYSTEMMODAL + $MB_OK + $MB_ICONERROR, "DllOpen Error", "Dll file does not exist: " & @CRLF & $sDLLFile)
				Return 0
			EndIf
		EndIf
	Else
		If $sParam = 'DllClose' Then
			DllClose($g__hDll_DPVS)
			$g__hDll_DPVS = ''
		EndIf

	EndIf
	Return $g__hDll_DPVS
EndFunc   ;==>_DPVS_StartUp

Func _DPVS_ObjCreate($sParam = Default)
	; Create ActivX object
	Local Static $oDPVS = Default
	If $sParam = '' Then
		$oDPVS = ''
		Return $oDPVS
	Else
		If $oDPVS = Default Then

			#CS
				; Viewer v11.13
				Local $sCLSID_Commercial = '{3AC8E67E-7080-47A0-83DD-66A57CED12E9}'
				Local $sIID_Commercial = '{05408D9A-4941-4F70-8281-10145A483964}'
				$oDPVS = ObjCreate($sCLSID_Commercial, $sIID_Commercial, _DPVS_StartUp())
				$oDPVS.LibraryPath = @ScriptDir & '\DebenuPDFLibraryDLL1113.dll'
				$oDPVS.RendererPath = @ScriptDir & '\DebenuPDFRendererDLL1113.dll'

			#CE

			; Viewer v11.14
			Local $sCLSID_Commercial = '{3AC8E67E-7080-47A0-83DD-66A57CED12E9}'
			Local $sIID_Commercial = '{05408D9A-4941-4F70-8281-10145A483964}'
			$oDPVS = ObjCreate($sCLSID_Commercial, $sIID_Commercial, _DPVS_StartUp())
			$oDPVS.LibraryPath = @ScriptDir & '\DebenuPDFLibraryDLL1114.dll'
			$oDPVS.RendererPath = @ScriptDir & '\DebenuPDFRendererDLL1114.dll'

;~ 			MsgBox(0, '', 1)
;~ 			$oDPVS.DQPLSetGDIPlusOptions(3, 1) ; Turn on image smoothing
;~ 			MsgBox(0, '', 2)
		EndIf
		Return $oDPVS
	EndIf
EndFunc   ;==>_DPVS_ObjCreate

Func _DPVS_ObjDestroy()
	_DPVS_ObjCreate('')
EndFunc   ;==>_DPVS_ObjDestroy

Func _DPVS_OnExit()
	OnAutoItExitRegister('_DPVS_GUI_Destroy')
EndFunc   ;==>_DPVS_OnExit

Func _DPVS_Viewer_Adlib()
	Local $hWnd = _DPVS__GUI()
	Local Static $iGUI_PDFWidth = WinGetPos($hWnd)[2] - 20
	Local Static $iGUI_PDFHeight = WinGetPos($hWnd)[3] - 40
	Local $bMakeRefresh = False
	If $iGUI_PDFWidth <> WinGetPos($hWnd)[2] - 20 Then $bMakeRefresh = True
	If $iGUI_PDFHeight <> WinGetPos($hWnd)[3] - 40 Then $bMakeRefresh = True

	If $bMakeRefresh Then
		$iGUI_PDFWidth = WinGetPos($hWnd)[2] - 20
		$iGUI_PDFHeight = WinGetPos($hWnd)[3] - 40
		Local $obj = _DPVS_ObjCreate()
		Local $AXControl = _DPVS_CtrlObjCreate($obj)
		GUICtrlSetPos($AXControl, 5, 5, $iGUI_PDFWidth, $iGUI_PDFHeight)
		MsgBox(0, '', 'move')
	EndIf

EndFunc   ;==>_DPVS_Viewer_Adlib

#EndRegion DPViewer.au3 - INIT

#Region DPViewer.au3 - GUI

Func _DPVS__GUI($sTitle = "DPVS PDF Viewer", $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default, $hParrent = Default)
	Local Static $hWnd = Default
	If $sTitle = 'GUIDelete' And IsHWnd($hWnd) = 1 Then
		GUIDelete($hWnd)
	EndIf
	If $hWnd = Default Or IsHWnd($hWnd) = 0 Then
;~ 		$hWnd = GUICreate("DPVS PDF Viewer", 800, 600, (@DesktopWidth - 800) / 2, (@DesktopHeight - 600) / 2, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS, $WS_CLIPCHILDREN),-1,$hParrent)
		$hWnd = GUICreate( _
				$sTitle, _
				$iWidth, $iHeight, $iLeft, $iTop, _
				 - 1, -1, _
				$hParrent _
				)
;~ 				BitOR($WS_POPUP, $WS_CAPTION), -1, _
;~ 				BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS, $WS_CLIPCHILDREN), -1, _
	EndIf
	Return $hWnd
EndFunc   ;==>_DPVS__GUI

Func _DPVS__GUI_ChangeTitle($sNewTitle)
	WinSetTitle(_DPVS__GUI(), '', $sNewTitle)
EndFunc   ;==>_DPVS__GUI_ChangeTitle

Func _DPVS_CtrlObjCreate(ByRef $oDPVS, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	Local Static $idAXControl = Default
	If _
			(Not $idAXControl = Default) _
			And (Not IsObj($oDPVS)) _
			Then
		GUICtrlDelete($idAXControl)
	EndIf

	If $iLeft = Default And $iTop = Default And $iWidth = Default And $iHeight = Default Then
		$iLeft = 1
		$iTop = 1
		$iWidth = WinGetPos(_DPVS__GUI())[2] - 12
		$iHeight = WinGetPos(_DPVS__GUI())[3] - 65
	EndIf
	If $idAXControl = Default Then
		GUISwitch(_DPVS__GUI())
		$idAXControl = GUICtrlCreateObj($oDPVS, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idAXControl
EndFunc   ;==>_DPVS_CtrlObjCreate

Func _DPVS_CtrlObjDelete()
	Local $oDPVS = ''
	_DPVS_CtrlObjCreate($oDPVS)
EndFunc   ;==>_DPVS_CtrlObjDelete
Func _DPVS_GUI_Destroy()
;~ 	MsgBox(0, '', '_DPVS_GUI_Destroy()')
	_DPVS_CtrlObjDelete()
;~ 	MsgBox(0, '', '_DPVS_CtrlObjDelete()')
	_DPVS_ObjDestroy()
;~ 	MsgBox(0, '', '_DPVS_ObjDestroy()')
	_DPVS__GUI('GUIDelete')
;~ 	MsgBox(0, '', 'GUIDelete(_DPVS__GUI())')
	_DPVS_Shutdown()
;~ 	MsgBox(0, '', '_DPVS_Shutdown()')
EndFunc   ;==>_DPVS_GUI_Destroy

Func _DPVS_Hide()
	WinSetState(_DPVS__GUI(), '', @SW_HIDE)
EndFunc   ;==>_DPVS_Hide

Func _DPVS_SetBackgroundColor_RGB(ByRef $oDPVS, $dRedComponentColor = 0x80, $dGreenComponentColor = 0x90, $dBlueComponentColor = 0xff)
	Local $aColor[3] = [$dRedComponentColor, $dGreenComponentColor, $dBlueComponentColor]
	$oDPVS.BackgroundColor = _ColorSetCOLORREF($aColor)
;~ 		$oDPVS.Refresh()
EndFunc   ;==>_DPVS_SetBackgroundColor_RGB

Func _DPVS_Show()
	WinSetState(_DPVS__GUI(), '', @SW_SHOW)
EndFunc   ;==>_DPVS_Show

#EndRegion DPViewer.au3 - GUI

#Region DPViewer.au3 - GUI - Buttons

Func _DPVS_ButtonBack($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Back = Default
	If $idButton_Back = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Back = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Back
EndFunc   ;==>_DPVS_ButtonBack

Func _DPVS_ButtonClose($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Close = Default
	If $idButton_Close = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Close = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Close
EndFunc   ;==>_DPVS_ButtonClose

Func _DPVS_ButtonForward($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Forward = Default
	If $idButton_Forward = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Forward = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Forward
EndFunc   ;==>_DPVS_ButtonForward

Func _DPVS_ButtonHome($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Home = Default
	If $idButton_Home = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Home = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Home
EndFunc   ;==>_DPVS_ButtonHome

Func _DPVS_ButtonOpen($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Open = Default
	If $idButton_Open = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Open = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Open
EndFunc   ;==>_DPVS_ButtonOpen

Func _DPVS_ButtonSave($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Save = Default
	If $idButton_Save = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Save = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Save
EndFunc   ;==>_DPVS_ButtonSave

#EndRegion DPViewer.au3 - GUI - Buttons

#Region DPViewer.au3 - File Operations

Func _DPVS_OpenFile(ByRef $oDPVS, $sPDF_FileFullPath)
	GUISetState(@SW_LOCK, _DPVS__GUI())
	$oDPVS.OpenFile($sPDF_FileFullPath)
	$oDPVS.ZoomFitWidth()
	$oDPVS.GotoPage(1)
	GUISetState(@SW_UNLOCK, _DPVS__GUI())
EndFunc   ;==>_DPVS_OpenFile

Func _DPVS_SaveToFile(ByRef $oDPVS, $sPDF_FileFullPath = Default)
	Local $iError = 0
	If $sPDF_FileFullPath = Default Or $sPDF_FileFullPath = '' Then
		$sPDF_FileFullPath = FileSaveDialog('Save PDF File', @ScriptDir, 'PDF File (*.pdf)', $FD_PATHMUSTEXIST, '', _DPVS__GUI())
		$iError = @error
	EndIf
	If $iError Then
		Return SetError($iError)
	Else
		If StringRight($sPDF_FileFullPath, 4) <> '.pdf' Then
			$sPDF_FileFullPath &= '.pdf'
		EndIf
		$oDPVS.DQPLSaveToFile($sPDF_FileFullPath)
		Return $sPDF_FileFullPath
	EndIf
EndFunc   ;==>_DPVS_SaveToFile
#EndRegion DPViewer.au3 - File Operations

#Region DPViewer.au3 -_DPVS_EVENT

Func _DPVS_EVENT_zoomChanged($vZoom)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "zoomChanged" was fired : $vZoom = ' & $vZoom & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_zoomChanged

Func _DPVS_EVENT_vScrollbarChanged($vMax, $vValue)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "vScrollbarChanged" was fired : $vMax = ' & $vMax & ' $vValue = ' & $vValue & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_vScrollbarChanged

Func _DPVS_EVENT_hScrollbarChanged($vMax, $vValue)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "hScrollbarChanged" was fired : $vMax = ' & $vMax & ' $vValue = ' & $vValue & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_hScrollbarChanged

Func _DPVS_EVENT_pageChanged($iCurrentPage)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "pageChanged" was fired : $iCurrentPage = ' & $iCurrentPage & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_pageChanged

Func _DPVS_EVENT_pageCountChanged($iPageCount)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "pageCountChanged" was fired : $iPageCount = ' & $iPageCount & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_pageCountChanged

Func _DPVS_EVENT_FocusGained($hWnd_Old)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "FocusGained" was fired : $hWnd_Old = ' & $hWnd_Old & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_FocusGained

Func _DPVS_EVENT_FocusLost($hWnd_New)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "FocusLost" was fired : $hWnd_New = ' & $hWnd_New & @CR)
	EndIf
EndFunc   ;==>_DPVS_EVENT_FocusLost

Func _DPVS_EVENT_pageMouseDown($iPageNumber, $iXPos, $iYPos)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "pageMouseDown" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
EndFunc   ;==>_DPVS_EVENT_pageMouseDown

Func _DPVS_EVENT_pageMouseUp($iPageNumber, $iXPos, $iYPos)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "pageMouseUp" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
EndFunc   ;==>_DPVS_EVENT_pageMouseUp

Func _DPVS_EVENT_pageMouseMove($iPageNumber, $iXPos, $iYPos)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "pageMouseMove" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
EndFunc   ;==>_DPVS_EVENT_pageMouseMove

Func _DPVS_EVENT_pageMouseDblClick($iPageNumber, $iXPos, $iYPos)
	if $g__bEventConsoleNotification Then
		ConsoleWrite('Event "pageMouseDblClick" was fired : $iPageNumber = ' & $iPageNumber & ' $iXPos = ' & $iXPos & '  $iYPos = ' & $iYPos & @CR )
	EndIf
EndFunc   ;==>_DPVS_EVENT_pageMouseDblClick

#EndRegion DPViewer.au3 -_DPVS_EVENT

#Region DPViewer.au3 - Testing
; Parameters for SetMeasurementUnits

;~ _DPVS_StartUp()

#CS
	Global Enum _
	$__eQPDF_MUNITS_Default = 0, _
	$__eQPDF_MUNITS_Milimeters, _
	$__eQPDF_MUNITS_Inches

	; Parameters for SetOrigin
	Global Enum _
	$__eQPDF_SORIGIN_BottomLeft = 0, _
	$__eQPDF_SORIGIN_TopLeft, _
	$__eQPDF_SORIGIN_TopRight, _
	$__eQPDF_SORIGIN_BottomRight

#CE

#EndRegion
