#Tidy_Parameters=/sort_funcs /reel
#include "DPViewer.au3"
#include "Color.au3"

Global Enum _
		$g__eQPDF_MUNITS_Default = 0, _
		$g__eQPDF_MUNITS_Milimeters, _
		$g__eQPDF_MUNITS_Inches

; Parameters for SetOrigin
Global Enum _
		$g__eQPDF_SORIGIN_BottomLeft = 0, _
		$g__eQPDF_SORIGIN_TopLeft, _
		$g__eQPDF_SORIGIN_TopRight, _
		$g__eQPDF_SORIGIN_BottomRight

;~ _DPVS_StartUp()
_Example_MakeFullGui()

; #FUNCTION# ====================================================================================================================
; Name ..........: _DPVS_ButtonStamp
; Description ...: Additional Button to Add some stamp to the PDF
; Syntax ........: _DPVS_ButtonStamp([$sText = Default[, $iLeft = Default[, $iTop = Default[, $iWidth = Default[, $iHeight = Default]]]]])
; Parameters ....: $sText               - [optional] a string value. Default is Default.
;                  $iLeft               - [optional] an integer value. Default is Default.
;                  $iTop                - [optional] an integer value. Default is Default.
;                  $iWidth              - [optional] an integer value. Default is Default.
;                  $iHeight             - [optional] an integer value. Default is Default.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _DPVS_ButtonStamp($sText = Default, $iLeft = Default, $iTop = Default, $iWidth = Default, $iHeight = Default)
	If $iTop = Default Then $iTop = WinGetPos(_DPVS__GUI())[3] - $iHeight - 30
	Local Static $idButton_Make_a_STAMP = Default
	If $idButton_Make_a_STAMP = Default Then
		GUISwitch(_DPVS__GUI())
		$idButton_Make_a_STAMP = GUICtrlCreateButton($sText, $iLeft, $iTop, $iWidth, $iHeight)
	EndIf
	Return $idButton_Make_a_STAMP
EndFunc   ;==>_DPVS_ButtonStamp

Func _Example_MakeFullGui()
	Local $hWnd = _DPVS__GUI('PDF', 100, 10, 800, 700)
	WinSetOnTop(_DPVS__GUI(), '', 1)
	GUISetState(@SW_SHOW)

	_DPVS_ButtonBack("Back", 10, Default, 100, 30)
	_DPVS_ButtonForward("Forward", 120, Default, 100, 30)
	_DPVS_ButtonHome("Home", 230, Default, 100, 30)
	_DPVS_ButtonOpen("Open", 340, Default, 100, 30)
	_DPVS_ButtonSave("Save", 450, Default, 100, 30)
	_DPVS_ButtonClose("Close", 560, Default, 100, 30)
	_DPVS_ButtonStamp("Stamp", 670, Default, 100, 30)

	; Show GUI
	GUISetState(@SW_SHOW)

	; create Debenu Viewer Object
;~ 	Local $oDPVS = ObjCreate('DPVACTIVEX.Viewer')
	Local $oDPVS = _DPVS_ObjCreate()

	; ENTER YOUR LICENCE KEY HERE
	Local $sLicenceKey = ''
	; I (mLipok) use MyLicenceKey.txt file to prevent accidentally placed my license key in a public forum.
	If FileExists(@ScriptDir & '\MyLicenceKey.txt') Then $sLicenceKey = FileRead(@ScriptDir & '\MyLicenceKey.txt')

	_DPVS_LicenceKey($oDPVS, $sLicenceKey)
	Local $aColor[3] = [0x80, 0x90, 0xff]
	$oDPVS.BackgroundColor = _ColorSetCOLORREF($aColor)
;~ 	$oDPVS.Refresh()

;~ 	$oDPVS.DQPLSetGDIPlusOptions(3, 1)
;~ 	$oDPVS.DQPLSetGDIPlusOptions(3, 1)
;~ 	$oDPVS.DQPLSetGDIPlusOptions(10, 1)

	; some set up
	$oDPVS.ScrollbarsEnabled = True
;~ 	$oDPVS.ZoomFitWidth()
;~ 	$oDPVS.ToolbarEnabled = True

	_DPVS_CtrlObjCreate($oDPVS)

;~ 	ObjEvent($oDPVS, '_DPVS_EVENT_', 'DPVACTIVEX.Viewer')
;~ 	ObjEvent($oDPVS, '_DPVS_EVENT_', 'DPVACTIVEX.Viewer Control')
;~ 	ObjEvent($oDPVS, '_DPVS_EVENT_', 'DPVACTIVEX.Viewer Control')
	ObjEvent($oDPVS, '_DPVS_EVENT_')

	; Loop until the user exits.
	Local $iMsg
	AdlibRegister(_DPVS_Viewer_Adlib())
	_DPVS_OnExit()
	$g__bEventConsoleNotification = True

	Local $sPDF_FileFullPath = '', $aFileList
	While 1
		$iMsg = GUIGetMsg()

		Select
			Case $iMsg = $GUI_EVENT_CLOSE
				ExitLoop
			Case $iMsg = _DPVS_ButtonBack()
				$oDPVS.PrevPage()
			Case $iMsg = _DPVS_ButtonForward()
				$oDPVS.NextPage()
			Case $iMsg = _DPVS_ButtonHome()
				$oDPVS.GotoPage(1)
			Case $iMsg = _DPVS_ButtonOpen()
				$sPDF_FileFullPath = FileOpenDialog('Select PDF File', @ScriptDir, 'PDF File (*.pdf)')
				If @error Then

				Else
					_DPVS_OpenFile($oDPVS, $sPDF_FileFullPath)
					_DPVS__GUI_ChangeTitle(StringRegExp($sPDF_FileFullPath, '(?i).+\\(.*\.pdf)', 3)[0])
;~ 					MsgBox(0, "$oDPVS.SearchPDFText('e')", $oDPVS.SearchPDFText('e'))
;~ 					MsgBox(0, "$oDPVS.NextSearchResult()", $oDPVS.NextSearchResult())
;~ 					MsgBox(0, "$oDPVS.NextSearchResult()", $oDPVS.NextSearchResult())
;~ 					MsgBox(0, "$oDPVS.PrevSearchResult()", $oDPVS.PrevSearchResult())
				EndIf

			Case $iMsg = _DPVS_ButtonSave()
				$oDPVS.CompressContent()
				$sPDF_FileFullPath = _DPVS_SaveToFile($oDPVS)

				If Not @error Then
					_DPVS__GUI_ChangeTitle(StringRegExp($sPDF_FileFullPath, '(?i).+\\(.*\.pdf)', 3)[0])
				EndIf
			Case $iMsg = _DPVS_ButtonClose()
				$oDPVS.CloseFile()
				$oDPVS.RefreshDocument()

			Case $iMsg = _DPVS_ButtonStamp()
;~ 				_Make_a_STAMP($oDPVS, 20, 45, 'MY OFFICE' & @CRLF & 'My Name', '20-09-2014', '12:07', 1, 'my ID #')
				$oDPVS.DQPLSetOrigin($g__eQPDF_SORIGIN_TopLeft);
				$oDPVS.DQPLSetMeasurementUnits($g__eQPDF_MUNITS_Milimeters)
				$oDPVS.DQPLNormalizePage(0)
				_Make_a_STAMP($oDPVS, 20, 10, 'My Organization Name ' & @CRLF & 'My Name', '20-09-2014', '12:07', 1, 'my ID #')
				$oDPVS.ZoomOut()
				$oDPVS.ZoomIn()
		EndSelect

	WEnd
	$oDPVS = '' ; CleanUp

	GUIDelete()
EndFunc   ;==>_Example_MakeFullGui

; #FUNCTION# ====================================================================================================================
; Name ..........: _Make_a_STAMP
; Description ...: make a stamp in an opened document
; Syntax ........: _Make_a_STAMP(Byref $oDPVS, $iLeft, $iTop, $sOrganizationName, $sDate, $sTime, $iNoOfAttachments, $sSignID)
; Parameters ....: $oDPVS               - [in/out] reference to the ActiveX object
;                  $iLeft               - An integer value.
;                  $iTop                - An integer value.
;                  $sOrganizationName   - A string value.
;                  $sDate               - A string value.
;                  $sTime               - A string value.
;                  $iNoOfAttachments    - An integer value.
;                  $sSignID             - A string value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......: You should open document before you use this function
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _Make_a_STAMP(ByRef $oDPVS, $iLeft, $iTop, $sOrganizationName, $sDate, $sTime, $iNoOfAttachments, $sSignID)
	Local $iStampWidth = 75, $iStampHeight = 35
	$iLeft = Number($iLeft)
	$iTop = Number($iTop)
	$oDPVS.DQPLSetOrigin($g__eQPDF_SORIGIN_TopLeft);
	$oDPVS.DQPLSetMeasurementUnits($g__eQPDF_MUNITS_Milimeters)
	$oDPVS.DQPLSetTransparency(20)
	$oDPVS.DQPLSetLineWidth(1)
	$oDPVS.DQPLSetLineColor(1, 0, 0)
	$oDPVS.DQPLDrawBox($iLeft, $iTop, $iStampWidth, $iStampHeight, 0)
	Local $iIDFont = $oDPVS.DQPLAddTrueTypeFont('Arial {1250}', 0)
	$oDPVS.DQPLSelectFont($iIDFont)
	$oDPVS.DQPLSetTextSize(10)
	$oDPVS.DQPLSetTextAlign(1)
	$oDPVS.DQPLDrawWrappedText($iLeft + 2, $iTop + 5, $iStampWidth - 4, $sOrganizationName)
	$oDPVS.DQPLSetTextSize(11)
	$oDPVS.DQPLDrawWrappedText($iLeft + 2, $iTop + 25, $iStampWidth - 4, 'received: ' & $sDate & '  time: ' & $sTime)
	$oDPVS.DQPLDrawWrappedText($iLeft + 2, $iTop + 30, $iStampWidth - 4, '# of Attach.: ' & $iNoOfAttachments & '    Sign #: ' & $sSignID)
EndFunc   ;==>_Make_a_STAMP
